# Standard defines:
CC  	=	gcc

WRES	=	windres

HOMEV	=	
VPATH	=	$(HOMEV)/include
oDir	=	.
Bin	=	.
Src	=	.
libDirs	=	-L..\libdict-0.2.0
incDirs	=	-I..\libdict-0.2.0 -I..\openssl-0.9.7d\outinc
LIBS	=	-lws2_32 -ldict -s
C_FLAGS	=	-O2 -Wall -DUSE_SSL

SRCS	=\
	$(Src)/tstream.c\
	$(Src)/getopt.c\
	$(Src)/screen.c\
	$(Src)/rcon.c\
	$(Src)/queue.c\
	$(Src)/md5.c\
	$(Src)/main.c\
	$(Src)/slist.c\
	$(Src)/menu.c

EXOBJS	=\
	$(oDir)/tstream.o\
	$(oDir)/getopt.o\
	$(oDir)/screen.o\
	$(oDir)/rcon.o\
	$(oDir)/queue.o\
	$(oDir)/md5.o\
	$(oDir)/main.o\
	$(oDir)/slist.o\
	$(oDir)/menu.o

ALLOBJS	=	$(EXOBJS)
ALLBIN	=	$(Bin)/rconip.exe
ALLTGT	=	$(Bin)/rconip.exe

# User defines:

#@# Targets follow ---------------------------------

all:	$(ALLTGT)

objs:	$(ALLOBJS)

cleanobjs:
	rm -f $(ALLOBJS)

cleanbin:
	rm -f $(ALLBIN)

clean:	cleanobjs cleanbin

cleanall:	cleanobjs cleanbin

$(Bin)/rconip.exe: $(EXOBJS)
	$(CC) -o $(Bin)/rconip.exe $(EXOBJS) $(incDirs) $(libDirs) $(LIBS)

$(oDir)/tstream.o: tstream.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/getopt.o: getopt.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/screen.o: screen.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/rcon.o: rcon.c rcon.h md5.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/queue.o: queue.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/md5.o: md5.c md5.h md5_loc.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/main.o: main.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/slist.o: slist.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<

$(oDir)/menu.o: menu.c rcon.h
	$(CC) $(C_FLAGS) $(incDirs) -c -o $@ $<
